﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using FATX_Browser.FATX;

namespace FATX_Browser
{
    public partial class Extraction : Form
    {
        System.Threading.Thread t;
        System.Threading.Thread TTimer;
        string Path;
        Timer timer;
        string updateText = "";
        long pb1val = 0;
        long pb1maxval = 1;
        string garbage;
        bool DeletionMode;

        public Extraction(File f, string path, bool DoDeletedEntries)
        {
            InitializeComponent();
            DeletionMode = DoDeletedEntries;
            System.Threading.ThreadStart ts = delegate { DoExtract(f); };
            t = new System.Threading.Thread(ts);
            Path = path;
            timer = new Timer();
            timer.Tick += new EventHandler(timer_Tick);
            TTimer = new System.Threading.Thread(new System.Threading.ThreadStart(timer.Start));
            t.Start();
            timer.Interval = 500;
            timer.Enabled = true;
            TTimer.Start();
        }

        public Extraction(Folder f, string path, bool DoDeletedEntries)
        {
            InitializeComponent();
            DeletionMode = DoDeletedEntries;
            System.Threading.ThreadStart ts = delegate { DoExtract(f); };
            t = new System.Threading.Thread(ts);
            Path = path;
            timer = new Timer();
            timer.Tick += new EventHandler(timer_Tick);
            TTimer = new System.Threading.Thread(new System.Threading.ThreadStart(timer.Start));
            t.Start();
            timer.Interval = 500;
            timer.Enabled = true;
            TTimer.Start();
        }

        void timer_Tick(object sender, EventArgs e)
        {
            label1.Invoke(new UpdateLabel(UpdateLabelDawg), new object[] { updateText });
            progressBar1.Invoke(new UpdateProgressBarMax(UpdatePBMax), new object[] { pb1maxval });
            progressBar1.Invoke(new UpdateProgressBar(UpdatePB), new object[] { pb1val });
        }

        private void DoExtract(FATX.Folder f)
        {
            if (!this.IsAccessible)
            {
                System.Threading.Thread.Sleep(750);
            }
            updateText = f.Name;
            bool result = f.ExtractRecursive(Path, ref garbage, ref updateText, ref pb1val, ref pb1maxval ,false, DeletionMode);
            if (result == false)
            {
                MessageBox.Show("Fuck, error");
            }
            TTimer.Abort();
            timer.Enabled = false;
            this.Invoke(new call_FormClose(FormClose));
        }

        private bool CheckAccessability()
        {
            while (!this.IsAccessible)
            {
                //Do nothing until we can see the form
            }
            return true;
        }

        private void DoExtract(FATX.File f)
        {
            if (!this.IsAccessible)
            {
                System.Threading.Thread.Sleep(750);
            }
            updateText = f.Name;
            t.Priority = System.Threading.ThreadPriority.Highest;
            FATX.Entries e = new FATX_Browser.FATX.Entries(f);
            bool result = e.ExtractFile(f, Path, ref pb1val, ref pb1maxval);
            if (result == false)
            {
                MessageBox.Show("Fuck, error");
            }
            TTimer.Abort();
            timer.Enabled = false;
            this.Invoke(new call_FormClose(FormClose));
        }

        private delegate void UpdateLabel(string text);

        private delegate void UpdateProgressBar(long val);

        private delegate void UpdateProgressBarMax(long maxVal);

        private delegate void call_FormClose();
        private void FormClose()
        {
            this.Close();
        }

        private void UpdatePB(long val)
        {
            progressBar1.Value = (int)pb1val;
        }

        private void UpdatePBMax(long val)
        {
            progressBar1.Maximum = (int)pb1maxval;
        }

        private void UpdateLabelDawg(string text)
        {
            label1.Text = "File: " + text;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            t.Abort();
        }
    }
}
